/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#ifndef CONTROLLER_H
#define CONTROLLER_H
#include <assert.h>


class Controller  {
public:
	Controller(unsigned int nInputs, unsigned int nOutputs);
	virtual ~Controller();

	float getOutput(unsigned int i){
		assert(i<nOutputs);
		return output[i];
	}

	void setInput(unsigned int i, float value){
		assert(i<nInputs);
		input[i]=value;
	}

	virtual void advanceTime(){}
	
	unsigned int nInputs;
	unsigned int nOutputs;

protected:
	float* input;
	float* output;

};

#endif //CONTROLLER_H

