/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#if !defined(AFX_GRAPHDATA_H__035AC771_F046_4ECA_BCDE_E570A1138AE4__INCLUDED_)
#define AFX_GRAPHDATA_H__035AC771_F046_4ECA_BCDE_E570A1138AE4__INCLUDED_

#include <assert.h>

class GraphData  {
public:
	GraphData(int bufferSize);
	virtual ~GraphData();

	/** The size of the memory buffer of the graph  */
	int bufferSize;

	/** The actual size of the data that was already set. */
	int dataSize;

	/** The index that marks the start of the data. Virtually, the new data values added to the graph
	are pushed at the end of the data stack, while old values are popped at the beginning. In practice,
	just the index that marks the start of the data moves, while the new data values are overwritten
	over the older ones. */
	int index;

	void push(float value){
		if(dataSize<bufferSize){
			data[dataSize]=value;
			dataSize++;
		} else {
			data[(index+dataSize)%dataSize]=value;
			index++;
		}
	}
	
	float getValue(int i){
		assert(i<dataSize);
		return data[(index+i)%dataSize];
	}

private:
	float* data;

};


#endif // !defined(AFX_GRAPHDATA_H__035AC771_F046_4ECA_BCDE_E570A1138AE4__INCLUDED_)
