/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// Iunctus.h: interface for the Iunctus class.
//
//////////////////////////////////////////////////////////////////////

#ifndef IUNCTUS_H
#define IUNCTUS_H

#include "ArticulatedAgentQuasistatic.h"
#include "RandomController.h"
#include "VisualSensor.h"

class Iunctus : public ArticulatedAgentQuasistatic  {
public:

	Iunctus(real x=2.0, real y=0.8, std::string label="Iunctus");

	virtual ~Iunctus();

	Circle* myBody;
	VisualSensor* eye;

	void build(real x=2.0, real y=0.8);

	void proprioception();

	virtual void deleteContacts(){
		ArticulatedAgentQuasistatic::deleteContacts();
		eye->deleteContacts();
	}

	void controll();

	void draw(GUI *gui);

	RandomController* controller;

};

#endif //IUNCTUS_H
