/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#include "Application.h"
#include "PacSimulator.h"
#include "ThyrixMainFrame.h"

// Create a new application object: this macro will allow wxWindows to create
// the application object during program execution (it's better than using a
// static object for many reasons) and also declares the accessor function
// wxGetApp() which will return the reference of the right type (i.e. ThyrixApp and
// not wxApp)
IMPLEMENT_APP(Application)

Application::Application(){
	world=new PacSimulator();
}

Application::~Application(){
	delete world;
}


// 'Main program' equivalent: the program execution "starts" here
bool Application::OnInit(){
	
    /*
	wxXmlResource::Get()->InitAllHandlers(); 
	wxXmlResource::Get()->Load("resource/main_menubar.xrc");        
	wxXmlResource::Get()->Load("resource/main_toolbar.xrc");        
    */

	// create the main application window
	ThyrixMainFrame* frame = new ThyrixMainFrame(_("Pac World"),world);
	frame->Show(TRUE);
	SetTopWindow(frame);
  frame->start();

	// success: wxApp::OnRun() will be called which will enter the main message
	// loop and the application will run. If we returned FALSE here, the
	// application would exit immediately.
	return TRUE;
}