/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#ifndef AFX_COLORDEFINITIONS_H__AA2ABF89_C24B_4DA3_832F_B8EA68C11662__INCLUDED_
#define AFX_COLORDEFINITIONS_H__AA2ABF89_C24B_4DA3_832F_B8EA68C11662__INCLUDED_

#include <map>

class ColorDefinitions  {
public:
	ColorDefinitions();
	virtual ~ColorDefinitions();

	void setColor(unsigned char& r, unsigned char& g, unsigned char& b, const char* name);

private:

	struct SimpleColor {
		SimpleColor() {
			r=g=b=0;
		}
		SimpleColor(unsigned char x, unsigned char y, unsigned char z) {
			r=x; g=y; b=z;
		}
		unsigned char r, g, b;
	};

	struct ltstr {
		bool operator()(const char* s1, const char* s2) const  {
			return strcmp(s1, s2) < 0;
		}
	};

	std::map<const char*, SimpleColor, ltstr> names;

};

#endif // AFX_COLORDEFINITIONS_H__AA2ABF89_C24B_4DA3_832F_B8EA68C11662__INCLUDED_
