/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// ElasticLink.h: interface for the ElasticLink class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ELASTICLINK_H__CF42E708_6848_4CF4_B4DA_19E78FAA2BAC__INCLUDED_)
#define AFX_ELASTICLINK_H__CF42E708_6848_4CF4_B4DA_19E78FAA2BAC__INCLUDED_

#include "PhysicalObject.h"
#include "GUI.h"

/** An elastic link, linking two objects. The objects are connected in their reference point. */
class ElasticLink  {
public:
	ElasticLink(PhysicalObject* object1, PhysicalObject* object2, real length, real k);
	virtual ~ElasticLink();
	
	//The objects linked
	PhysicalObject* object1;
	PhysicalObject* object2;

	/** The rest length of the elastic link.*/
	real length;

	/** The elastic contact of the link. */
	real k;

	/** Applies the elastic forces to the objects, by adding them to the externalForces accumulator
	of the objects. */
	void applyForces();

	void draw(GUI* gui);

};

typedef std::vector<ElasticLink> ElasticLinkVector;

#endif // !defined(AFX_ELASTICLINK_H__CF42E708_6848_4CF4_B4DA_19E78FAA2BAC__INCLUDED_)
