/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

// GlobalContactInfo.h: interface for the GlobalContactInfo class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GLOBALCONTACTINFO_H
#define GLOBALCONTACTINFO_H

#include "ContactInfo.h"
#include "Vector2.h"

class GlobalContactInfo  {
public:
	GlobalContactInfo(ContactInfo* contact1, ContactInfo* contact2, real penetration=0.0){ 
		this->contact1=contact1; 
		this->contact2=contact2; 
		this->penetration=penetration; 
		force=(real)0.0; 
		alpha=0; 
	}

	/** Pointers to the contacts of the two objects that compose the contact. 
	The GlobalContactInfo does not own the ContactInfo objects, should NOT 
	delete them on destruction. */
	ContactInfo* contact1;
	ContactInfo* contact2;
	/** The modulus of the contact force. */
	real force;
	/** The penetration area. */
	real penetration;
	/** The index of this contact in the global contact vector. */
	int alpha;
};

typedef std::vector<GlobalContactInfo> GlobalContactInfoVector;

#endif //GLOBALCONTACTINFO_H
