/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#ifndef INTEGRATOR_H
#define INTEGRATOR_H

#include "Vector2.h"

class Integrator {
public:
	Integrator(real iniDt) : dt(iniDt) {}

	/** Gets the value of x at the next timestep, given its derivative v. */
	void integrate(real& x, const real& v) const { 
        x+=v*dt; 
    }
	
	void integrate(Vector2& x, const Vector2& v) const { 
        x.x+=v.x*dt; 
        x.y+=v.y*dt; 
    }

  real getDt() const {
      return dt;
  }

	void setDt(real t) {
		dt=t;
	}

private:
	real dt;
};

#endif //INTEGRATOR_H
