/* 
Thyrix, Copyright (C) 2004-2006 Razvan Florian / Coneural. All rights reserved.
http://www.thyrix.com 

Thyrix Lite is free software. You can redistribute it and/or
modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation; either version 2 
of the License, or (at your option) any later version. The text 
of the GNU General Public License is included with this library 
in the file GeneralPublicLicense.txt.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file
GeneralPublicLicense.txt for more details.
*/

#ifndef RANDOM_H__3E00EE5B_33A2_4F41_BEA5_4AAD68D5C1EE__INCLUDED_
#define RANDOM_H__3E00EE5B_33A2_4F41_BEA5_4AAD68D5C1EE__INCLUDED_
#include <stdlib.h>

class Random  {
public:
	Random();
	virtual ~Random();

	/** Sets the random number generator seed. If seed is 0, sets seed based on current time. */
	static void setSeed(unsigned int seed=0);

	/** Returns random float in [0,1). */
	static float getFloat(){
		return rand() / (float) RAND_MAX;
	}


	/** Returns random double in [0,1). */
	static double getDouble(){
		return rand() / (double) RAND_MAX;
	}

	/** Returns unsigned int in [0,n]*/
	static unsigned int getInt(unsigned int n){
		return rand() % (n+1);
	}

};

#endif // RANDOM_H__3E00EE5B_33A2_4F41_BEA5_4AAD68D5C1EE__INCLUDED_
